Index: funcs/func_shell.c
===================================================================
--- funcs/func_shell.c	(revision 312069)
+++ funcs/func_shell.c	(working copy)
@@ -48,11 +48,17 @@
 
 	if (len >= 1) {
 		FILE *ptr;
-		char plbuff[4096];
 
 		ptr = popen(data, "r");
-		while (fgets(plbuff, sizeof(plbuff), ptr)) {
-			strncat(buf, plbuff, len - strlen(buf) - 1);
+		while( len>0 && fgets(buf,len,ptr) ) {
+			size_t l = strlen( buf );
+			if( l > 0 ) {
+				buf += ( l - 1 );
+				/* replace the '\n' by '\r' to keep AGI result consistence */
+				if( *buf == '\n' ) *buf = '\r';
+				buf++;
+				len -= l;
+			}else break;
 		}
 		pclose(ptr);
 	}
